%define name webmin
%define version 0.87
%define release 4mdk
%define prefix %{_prefix}

Name: %{name}
Summary: An SSL web-based administration interface for Unix systems.
Version: %{version}
Release: %{release}
License: BSD
Group: System/Configuration/Other
URL: http://www.webmin.com/webmin/
Source0: http://www.webmin.com/webmin/download/%{name}-%{version}.tar.bz2
Source2: other.modules.tar.bz2
Source3: webmin-0.85-mdktheme.tar.bz2
Source4: webmin-postinstallscript.sh
Source5: webmin
Source6: webmin.initscript
Source7: http://www.webmin.com/webmin/updates/useradmin.wbm.bz2
Source8: http://www.webmin.com/webmin/updates/dhcpd.wbm.bz2
Source9: http://www.niemueller.de/webmin/modules/freeswan/freeswan-0.83.1.wbm.bz2
Source10: webmin.pam
Patch0: webmin-0.86-fix-configs.patch.bz2
Patch1: webmin-remove-atboot-problem.bz2
Patch4: webmin-fix-ssl.patch.bz2
Patch5: webmin-fix-newmods.patch.bz2
Patch6: webmin-0.84-fix-modules-configs.patch.bz2
Patch7: webmin-0.85-never-fail-detect-os.patch.bz2
Patch8: webmin-0.85-enable-changed-theme-at-installation.patch.bz2
Patch9: webmin-0.86-env.patch.bz2
Patch10: webmin-0.87-conf-samba-8.1.patch.bz2
Patch11: webmin-0.87-add-mdk-8.1.patch.bz2
Patch12: webmin-0.87-fix-param-browsers.patch.bz2
Requires: perl perl-CGI lsof
PreReq: sed chkconfig findutils fileutils initscripts grep perl-Net_SSLeay perl-Authen-PAM
Provides: %{name}-%{version}
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArchitectures: noarch

%description
A web-based administration interface for Unix systems. Using Webmin you
can configure DNS, Samba, NFS, local/remote filesystems, Apache,
Sendmail/Postfix, and more using your web browser.

After installation, enter the URL https://localhost:10000/ into your
browser and login as root with your root password. Please consider logging
in and modify your password for security issue.

PLEASE NOTE THAT THIS VERSION NOW USES SECURE WEB TRANSACTIONS: YOU HAVE
TO LOGIN TO "https://localhost:10000/" AND NOT "http://localhost:10000/".

%prep
%setup -q -a 2 -a 3
rm -fr %{name}-%{version}/dhcpd
rm -fr %{name}-%{version}/useradmin
%setup -q -D -T -c -a 7 -n %{name}-%{version}
%setup -q -D -T -c -a 8 -n %{name}-%{version}
%setup -q -D -T -c -a 9 -n %{name}-%{version}
%patch0 -p0
%patch1 -p1
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p1
%patch10 -p0
%patch11 -p0
%patch12 -p0
perl -pi -e 's|redhat-linux(?! mandrake-linux)|redhat-linux mandrake-linux| if $_ =~ /^os_support.*redhat-linux/ && $_ !~ /mandrake-linux/' */module.info

(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts-*
rm -f mount/openbsd-mounts-*

%install
rm -rf $RPM_BUILD_ROOT

# IMPORTANT: there is no %{_datadir} and so on, since the directories are decided by the post install script.
mkdir -p $RPM_BUILD_ROOT/usr/share/webmin
mkdir -p $RPM_BUILD_ROOT/%{_initrddir}
mkdir -p $RPM_BUILD_ROOT/usr/bin

find -type f | xargs chmod a+r
find -type d | xargs chmod a+rx

cp -a * $RPM_BUILD_ROOT/usr/share/webmin
install -m755 %{SOURCE6} $RPM_BUILD_ROOT/%{_initrddir}/webmin
install -m755 %{SOURCE4} $RPM_BUILD_ROOT/usr/share/webmin/postinstall.sh
install -m755 %{SOURCE5} $RPM_BUILD_ROOT/usr/bin

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d
install -m755 %{SOURCE10} $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/webmin

rm -rf $RPM_BUILD_ROOT/usr/share/webmin/*/{CVS,*/CVS}


%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" != 0 ]; then
    service webmin stop >/dev/null 2>/dev/null
fi
/usr/share/webmin/postinstall.sh
%_post_service webmin

%preun
%_preun_service webmin

%postun
if [ "$1" = 0 ]; then
	grep root=/usr/share/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	rm -rf /etc/webmin /var/webmin /var/lib/webmin /var/log/webmin
fi

%files
%defattr(-, root, root, 0755)
%doc README LICENCE
%config(noreplace) %{_initrddir}/webmin
%config(noreplace) %{_sysconfdir}/pam.d/webmin
/usr/share/webmin
/usr/bin/%{name}

%changelog
* Fri Sep 07 2001 Florin <florin@mandrakesoft.com> 0.87-4mdk
- add the squidguard module
- noreplace for the initscript

* Thu Aug 30 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.87-3mdk
- fix file permissions

* Wed Aug 29 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.87-2mdk
- author a patch on miniserv.pl to fix mozilla/curl/etc login
- remove -b option to patches so that we don't end up distributing
  files and their originally unpatched files counterparts
- use PAM for authentication, so simplify post_install stuff
- have to remove config-noreplace on the initscript since this fscking
  rpm seems silly about it (wants to save the old one as if user
  modified it) and I don't understand why :-(

* Mon Jul  2 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.87-1mdk
- new version
- complies with upcoming Mandrake-8.1 featuring samba config
  files in /etc/samba

* Fri Jun 15 2001 Vincent Danen <vdanen@mandrakesoft.com> 0.86-2mdk
- security patch to fix environment leaking
- test for /etc/webmin during postin so we don't get errors if webmin
  hasn't been used before upgrade

* Fri Jun  8 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.86-1mdk
- version 0.86

* Mon May 21 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.85-4mdk
- use a better /usr/bin/webmin thanks to Daouda

* Wed May  2 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.85-3mdk
- fix default printer config -> cups

* Mon Apr 30 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.85-2mdk
- requires lsof
- modifies initscript so that run of postinstall script will not fail
  if previous Webmin is still running

* Wed Apr 25 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.85-1mdk
- 0.85
- have a fallback when the OS is not detected
- write Mandrake config files for Webmin so that downloads from
  official website will not result in a too broken Webmin
- use our mdk icons as a Theme, per request of Webmin author

* Wed Apr 11 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-7mdk
- fix requires on perl-CGI

* Wed Apr 11 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-6mdk
- fix default config of MySQL

* Mon Apr  9 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-5mdk
- back in Linux-Mandrake 8.0 being compat with Redhat 7.0
- some fixes after bugreports from james@papaya.altamente.com
- some more default config fixes

* Thu Mar 29 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-4mdk
- use post/preun service macros

* Mon Mar 12 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-3mdk
- add freeswan module for chmouel

* Mon Feb 12 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-2mdk
- PreReq perl-SSL to avoid some potential problems
- have Linux-Mandrake-8.0 in list of known OS'es
- try to print a better error message in case of failing postinstall
  script

* Thu Jan 25 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.84-1mdk
- 0.84

* Sat Jan  6 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 0.83-2mdk
- took SRPM from Alexander Skwar <ASkwar@Linux-Mandrake.com>
  - Added a patch to the oslist, so that it works on the upcoming 7.3
    release of Mandrake
  - Applied the updates to webmin 0.83 listed on
    http://www.webmin.com/webmin/updates.html :
    - dhcpd: Hosts inside subnets are not being displayed properly in 
      some cases.
    - useradmin: New or modified users are having their primary group
      set to something wrong, such as bin.

* Tue Nov 28 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.83-1mdk
- 0.83

* Tue Nov  7 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.82-2mdk
- add reload entry in initscript

* Tue Oct 17 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.82-1mdk
- 0.82

* Thu Oct 12 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.81-1mdk
- 0.81

* Mon Oct  9 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-19mdk
- don't start in %post this is not the policy

* Wed Oct  4 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-18mdk
- fix run of post_install script according to initscripts
- try to fix the upgrade

* Tue Oct  3 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-17mdk
- remove cvs-internal-file in vacationadm, florin sucks

* Tue Sep 26 2000 Florin Grad <florin@mandrakesoft.com> 0.80-16mdk
- a typo error
- deletes /var/log/webmin along with the other directories

* Tue Sep 26 2000 Florin Grad <florin@mandrakesoft.com> 0.80-15mdk
- modify the postscript to create log files in /var/log instead of /root/tmp
- merged the postfix module to the other.modules.tar.bz2

* Mon Sep 25 2000 Florin Grad <florin@mandrakesoft.com> 0.80-14mdk
- added some third party modules:
- ssh applet, nettools, ipchains, netsaint, front page modules, vnc, IMAP, qmail,
- upload, batch-dns, batch-apache, isdn-status, backup, cdbackup, logviewer, calamaris,
- kannel, vacation admin, autorpm, ldap

* Sun Sep 24 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-13mdk
- change %description in order to strongly precise that this an SSL
  version because no one RTFM otherwise..

* Fri Sep 22 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-12mdk
- move log files from /tmp to /root/tmp for security issue, thx to Pixel

* Tue Sep  5 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-11mdk
- added Mandrake Linux 7.2 in list of supported OS
- is now secured through SSL connection

* Wed Aug 30 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-10mdk
- use %{_initrddir}
- %config(noreplace)
- better initscript

* Tue Aug 29 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-9mdk
- forgot to include the patch for initscript!! :-((

* Tue Aug 29 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-8mdk
- improved initscript to better comply to standards

* Wed Aug 23 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-7mdk
- automatically added packager tag

* Wed Jul 19 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-6mdk
- BM

* Tue Jun 20 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-5mdk
- now uses 0.80 final of Webmin

* Wed May 24 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-4mdk
- more bugfixes in postfix module, after bugreports by Charles

* Sat May 20 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-3mdk
- small bugfix in postfix module

* Thu May 18 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-2mdk
- patched "os_list.txt" to add the dectection of Linux Mandrake
  Corporate Server 1.0 and Linux Mandrake 7.1
- patched the post-install script which said "Mandrake 7.0" all
  the time if Webmin was installed during system install

* Fri May  5 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.80-1mdk
- upgrade to 0.80 beta with the kind help of Jamie, because of
  incompatibility between 0.79 and perl 5.6

* Wed May  3 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.79-5mdk
- updated postfix-mdkmodule so that it tests if postfix is running
  in a more portable way [uses kill -0 <pid>]
- updated install style so that it adds to the runlevel information
  at install time; thus it's okay now to select/deselect it in DrakX

* Thu Apr 20 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.79-4mdk
- fixed the hang of post install at boot time [grr]

* Wed Apr 19 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.79-3mdk
- fixed very bad security issue concerning exec of script during
  install
- added small executable to tell people that they have to connect
  through their web browser

* Mon Apr 17 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.79-2mdk
- fixed missing LICENCE file

* Fri Apr 14 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.79-1mdk
- 0.79
- updated postfix-mdkmodule with bugfixes and other stuff
- mdkicons now have a copyright

* Thu Apr  6 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.78-2mdk
- Updated Mandrake Icons
- Updated `PreRequires', and fixed the problem of /etc/issue,
  in order to not fail in install

* Mon Mar 27 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.78-1mdk
- Mandrake Icons

* Fri Mar 17 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 0.78-0.4mdk
- v0.78
- Postfix Module
- cleanup and debug of specfile with help of Chmouel :-)

* Thu Feb 10 2000 Lenny Cartier <lenny@mandrakesoft.com>
- v0.77
- used srpm provided by Vincent Danen <vdanen@linux-mandrake.com>

* Tue Feb 8 2000 Vincent Danen <vdanen@linux-mandrake.com>
- 0.77
- updated specfile based on the webmin source RPM (newly released, nice
  changes!)
- included the 0.73 ocstheme again (does anyone know of an update to this?)

* Thu Jan 13 2000 Vincent Danen <vdanen@linux-mandrake.com>
- 0.76

* Wed Dec 08 1999 Lenny Cartier <lenny@mandrakesoft.com>
- new in contribs
- used srpm provided by Vincent Danen <vdanen@linux-mandrake.com>

* Sun Dec 5 1999 Vincent Danen <vdanen@linux-mandrake.com>
- built specfile for Mandrake contribs
- based loosely on Leon Breedt's <leon@obsidian.co.za> SRPM for 0.73
- webmin-install.sh is now a source package, not built from patch
- bzip sources
